﻿//This shows the difference between target/currentTarget and MOUSE_OVER/ROLL_OVER
//NOTE that I have given all of the MovieCLips linkage names so that you can see them in the trace statements

package com.wastedpotential {
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	import flash.text.TextField;
	
	public class Main extends MovieClip {
		
		public function Main() {
			//TOP 2 BUTTONS: use MOUSE_OVER and MOUSE_OUT
			//multiple events are being fired for both buttons
			uglyButton1_mc.addEventListener(MouseEvent.MOUSE_OVER, targetMouseOver);
			uglyButton1_mc.addEventListener(MouseEvent.MOUSE_OUT, targetMouseOut);
			uglyButton2_mc.addEventListener(MouseEvent.MOUSE_OVER, currentTargetMouseOver);
			uglyButton2_mc.addEventListener(MouseEvent.MOUSE_OUT, currentTargetMouseOut);
			
			//MIDDLE 2 BUTTONS: use MOUSE_OVER and MOUSE_OUT with mouseChildren set to false
			//only one event fired for each button - target and currentTarget are the same
			uglyButton3_mc.mouseChildren = false;
			uglyButton3_mc.addEventListener(MouseEvent.MOUSE_OVER, targetMouseOver);
			uglyButton3_mc.addEventListener(MouseEvent.MOUSE_OUT, targetMouseOut);
			uglyButton4_mc.mouseChildren = false;
			uglyButton4_mc.addEventListener(MouseEvent.MOUSE_OVER, currentTargetMouseOver);
			uglyButton4_mc.addEventListener(MouseEvent.MOUSE_OUT, currentTargetMouseOut);
			
			//BOTTOM 2 BUTTONS: use ROLL_OVER and ROLL_OUT
			//only one event fired for each button - target and currentTarget are the same
			uglyButton5_mc.addEventListener(MouseEvent.ROLL_OVER, targetRollOver);
			uglyButton5_mc.addEventListener(MouseEvent.ROLL_OUT, targetRollOut);
			uglyButton6_mc.addEventListener(MouseEvent.ROLL_OVER, currentTargetRollOver);
			uglyButton6_mc.addEventListener(MouseEvent.ROLL_OUT, currentTargetRollOut);
		}

		//responds to MOUSE_OVER and sets target alpha to 50%:
		private function targetMouseOver(e:MouseEvent):void {
			e.target.alpha =.5;
			//trace(e.target);
			output_txt.text = "target = "+e.target+"... currentTarget = "+e.currentTarget;
		}
		
		//responds to MOUSE_OUT and sets target alpha to 100%:
		private function targetMouseOut(e:MouseEvent):void {
			e.target.alpha = 1;
		}
		
		//responds to MOUSE_OVER and sets currentTarget alpha to 50%:
		private function currentTargetMouseOver(e:MouseEvent):void {
			e.currentTarget.alpha = .5;
			//trace(e.target);
			output_txt.text = " target = "+e.target+"... currentTarget = "+e.currentTarget;
		}
		
		//responds to MOUSE_OUT and sets currentTarget alpha to 100%:
		private function currentTargetMouseOut(e:MouseEvent):void {
			e.currentTarget.alpha = 1;
		}
		
		//responds to ROLL_OVER and sets target alpha to 50%:
		private function targetRollOver(e:MouseEvent):void {
			e.target.alpha = .5;
			//trace(e.target);
			output_txt.text = " target = "+e.target+"... currentTarget = "+e.currentTarget;
		}
		
		//responds to ROLL_OUT and sets target alpha to 100%:
		private function targetRollOut(e:MouseEvent):void {
			e.target.alpha = 1;
		}

		//responds to ROLL_OVER and sets currentTarget alpha to 50%:
		private function currentTargetRollOver(e:MouseEvent):void {
			e.currentTarget.alpha = .5;
			//trace(e.target);
			output_txt.text = " target = "+e.target+"... currentTarget = "+e.currentTarget;
		}
		
		//responds to ROLL_OUT and sets currentTarget alpha to 100%:
		private function currentTargetRollOut(e:MouseEvent):void {
			e.currentTarget.alpha = 1;
		}
		
	} //end class
} //end package